local _, addon = ...

local mt = addon.mt
local util = addon.utility
local _G = _G

local player = UnitName("player")
local realm = GetRealmName()

local NORMAL_QUEST = 'QUEST_01'     -- Profits or Expenses from Normal Quests
local BONUS_OBJ_QUEST = 'QUEST_02'  -- Profits from Bonus Objective Quests

local function OnTrigger(uuid, t, m)
   if m > 0 then
      _G.WOWMSTracker[realm].AllChars[t].Earned = _G.WOWMSTracker[realm].AllChars[t].Earned + m
      _G.WOWMSTracker[realm][player][t].Earned = _G.WOWMSTracker[realm][player][t].Earned + m
      
      pcash = _G.WOWMMGlobal[realm].Chars[player].Cash
      local cash = pcash + m
      util.UpdateEarnedSpent(cash, pcash)
      util.UpdatePlayerCash(cash)
   else
      m = math.abs(m)
      _G.WOWMSTracker[realm].AllChars[t].Spent = _G.WOWMSTracker[realm].AllChars[t].Spent + m
      _G.WOWMSTracker[realm][player][t].Spent = _G.WOWMSTracker[realm][player][t].Spent + m
      
      pcash = _G.WOWMMGlobal[realm].Chars[player].Cash
      local cash = pcash - m
      util.UpdateEarnedSpent(cash, pcash)
      util.UpdatePlayerCash(cash)
   end
end

local currentTaskQID
local function BonusObjectiveOnActivation(c, qID)
   if IsQuestTask(qID) then
      currentTaskQID = qID
   end
end

local function BonusObjectiveOnDeactivation(qID)
   if qID == currentTaskQID then
      currentTaskQID = nil
   end
end

local function BonusObjectiveClassifier(uuid, qID, xpR, mR)
   if uuid == BONUS_OBJ_QUEST and qID == currentTaskQID then
      return uuid, mR
   end
end

mt.RegisterTracker(NORMAL_QUEST, 'QUEST', 'QUEST_COMPLETE','QUEST_FINISHED', OnTrigger)
mt.RegisterTracker(BONUS_OBJ_QUEST, 'QUEST', 'QUEST_ACCEPTED','QUEST_REMOVED', OnTrigger)
mt.RegisterOnActivation(BONUS_OBJ_QUEST, BonusObjectiveOnActivation)
mt.RegisterOnDeactivation(BONUS_OBJ_QUEST, BonusObjectiveOnDeactivation)
mt.RegisterDeterminant(BONUS_OBJ_QUEST, 'QUEST_TURNED_IN', BonusObjectiveClassifier)
